//
// FileGDBAPI.h
//

/*
  COPYRIGHT  2015 ESRI
  TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
  Unpublished material - all rights reserved under the
  Copyright Laws of the United States and applicable international
  laws, treaties, and conventions.

  For additional information, contact:
  Environmental Systems Research Institute, Inc.
  Attn: Contracts and Legal Services Department
  380 New York Street
  Redlands, California, 92373
  USA

  email: contracts@esri.com
*/

/// Convenience lynchpin include containing all of the file geodatabase API includes.
/// @file FileGDBAPI.h

#pragma once

#include "FileGDBCore.h"
#include "GeodatabaseManagement.h"
#include "Geodatabase.h"
#include "Table.h"
#include "Row.h"
#include "Util.h"
#include "Raster.h"
